BEGIN { idx = 0; doprint = 0; }
/^BEGIN:VCALENDAR$/ {
    fname = sprintf("ical%08d.ics", idx);
    printf("1 3 %s\n", fname) >> "backup_entries";
    doprint = 1;
    printf("BEGIN:VCALENDAR\n") > fname;
    next;
}
doprint && /^VERSION:1.0$/ {
    printf("VERSION:2.0\n") >> fname;
    next;
}
doprint && /^DESCRIPTION/ {
    sub(/^DESCRIPTION/, "SUMMARY", $0);
    ret = gensub(/CHARSET=[^;:]+([:;])/, "\\1", $0);
    sub(/;:/, ":", ret);
    printf("%s\n", ret) >> fname;
    next;
}
doprint && /^DCREATED/ {
    sub(/^DCREATED/, "DTSTAMP", $0);
    printf("%s\n", $0) >> fname;
    next;
}
doprint && /^RRULE/ {
    irule = $0;
    orule = "";
    if (match(irule, /^RRULE:D.*$/) != 0)
    {
	ival = gensub(/^RRULE:D([0-9]+).*$/, "\\1", irule);
	orule = sprintf("FREQ=DAILY;INTERVAL=%s", ival);
    }
    else if (match(irule, /^RRULE:W.*$/) != 0)
    {
	ival = gensub(/^RRULE:W([0-9]+).*$/, "\\1", irule);
	orule = sprintf("FREQ=WEEKLY;INTERVAL=%s", ival);
    }
    else if (match(irule, /^RRULE:YM.*$/) != 0)
    {
	ival = gensub(/^RRULE:YM([0-9]+).*$/, "\\1", irule);
	orule = sprintf("FREQ=YEARLY;INTERVAL=%s", ival);
    }
    else
    {
	orule = "noei:" irule;
    }
    printf("RRULE:%s\n", orule) >> fname;
    next;
}
doprint && /^AALARM/ {
    printf("BEGIN:VALARM\nACTION:AUDIO\nEND:VALARM\n") >> fname;
    next;
}
/^END:VCALENDAR$/ {
    printf("END:VCALENDAR\n") >> fname;
    ++idx;
    doprint = 0;
    next;
}
doprint && // {
   printf("%s\n", $0) >> fname;
   next;
}
